// -----------------------------------------------------------------------------------------------------------------------------------------
// Author: Tim Siwula      
// -----------------------------------------------------------------------------------------------------------------------------------------
// File: ElemIterator.java
// -----------------------------------------------------------------------------------------------------------------------------------------
// Purpose: SparseArray interface
// -----------------------------------------------------------------------------------------------------------------------------------------
// Abstract Data Type: Two seperate Linked list that make a grid.  
// -----------------------------------------------------------------------------------------------------------------------------------------
// Input: blah.
// -----------------------------------------------------------------------------------------------------------------------------------------
// Output: blah.
// -----------------------------------------------------------------------------------------------------------------------------------------
// Compile: command line here
// -----------------------------------------------------------------------------------------------------------------------------------------
// Run: command line here
// -----------------------------------------------------------------------------------------------------------------------------------------
// Dependencies: 
// -----------------------------------------------------------------------------------------------------------------------------------------
// Interfaces: SparseArray.java
// -----------------------------------------------------------------------------------------------------------------------------------------
// Notes: 
//	1. Both linked lists have dummy elements before the head to eliminate special cases. 
//	2.
//	3.
// -----------------------------------------------------------------------------------------------------------------------------------------


abstract class ElemIterator implements java.util.Iterator
{
	// -----------------------------------------------------------------------------------------------------------------------------------------
	// Abstract Methods -- ElemIterator -- interatingRow() -- 1 of 6.       
	// -----------------------------------------------------------------------------------------------------------------------------------------
	// Returns true if this iterator is iterating through a row that is, if this iterator was obtained from a call to next from a ColumnIterator
	// -----------------------------------------------------------------------------------------------------------------------------------------
	public abstract boolean interatingRow();
	
	// -----------------------------------------------------------------------------------------------------------------------------------------
	// Abstract Methods -- ElemIterator -- interatingCol() -- 2 of 6.       
	// -----------------------------------------------------------------------------------------------------------------------------------------
	//  Returns true if this iterator is iterating through a column that is, if this iterator was obtained from a call to next from a RowIterator
	// -----------------------------------------------------------------------------------------------------------------------------------------
	public abstract boolean iteratingColumn();
	
	// -----------------------------------------------------------------------------------------------------------------------------------------
	// Abstract Methods -- ElemIterator -- nonIteratingIndex() -- 3 of 6.       
	// -----------------------------------------------------------------------------------------------------------------------------------------
	//  If we are iterating through a row, return the index of the row we are traversing. 
	//  If we are iterating through a column, return the index of the column we are traversing	// -----------------------------------------------------------------------------------------------------------------------------------------
	public abstract int nonIteratingIndex();
	
	// -----------------------------------------------------------------------------------------------------------------------------------------
	// Abstract Methods -- ElemIterator -- next() -- 4 of 6.       
	// -----------------------------------------------------------------------------------------------------------------------------------------
	//  Returns the next element in the row (or column) we are traversing. 
	// -----------------------------------------------------------------------------------------------------------------------------------------
	public abstract MatrixElem next();
	
	// -----------------------------------------------------------------------------------------------------------------------------------------
	// Abstract Methods -- ElemIterator -- hasNext() -- 5 of 6.       
	// -----------------------------------------------------------------------------------------------------------------------------------------
	//  Returns true if there are more elements in this row/column	// -----------------------------------------------------------------------------------------------------------------------------------------
	public abstract boolean hasNext();
	
	// -----------------------------------------------------------------------------------------------------------------------------------------
	// Abstract Methods -- ElemIterator -- remove() -- 6 of 6.       
	// -----------------------------------------------------------------------------------------------------------------------------------------
	//  Note: This function is not implemented for this project but required by the java Iterator.	// -----------------------------------------------------------------------------------------------------------------------------------------
	public void remove()
	{
		throw new UnsupportedOperationException();
	}
}
